<?php

namespace Service;

use Zeedhi\Framework\DependencyInjection\InstanceManager;

class MigrationNextAccessControlRules
{
        public static function migrationNext($nrorgstring){
            header('Content-type: application/json; charset=utf-8');
            $nrorgs = explode(',',$nrorgstring);
            foreach ($nrorgs as $nrorg) {
                $projectId = '3794';
                $angulaRules = self::getAngulaRules($nrorg,$projectId);
                $angulaRules = self::setNodeNextByAclAngula($angulaRules);

                $menuNext = json_decode(@file_get_contents("../../aclLabels.json"), true);
                list($menusNodeNext,$menuTreeNext) = self::getMenuNode($menuNext);
                $arrayElementPorPerfilNext = $arrayElementPorPerfil = self::getPerfilAccess($nrorg);
                $arrayElementPorPerfilNext = self::getElementsNextByAngula($angulaRules, $arrayElementPorPerfil, $menusNodeNext, $arrayElementPorPerfilNext,$menuTreeNext);

                foreach ($arrayElementPorPerfilNext as $nrperfilacesso => $elements) {
                    foreach ($elements as $element) {
                        self::savePerfilacessoLabel($element, $nrperfilacesso, $nrorg);
                    }
                }
            }
        }

    protected static function setNodeNextByAclAngula($angulaRules)
    {
        $menuNext = json_decode(@file_get_contents("../../aclangulaForNext.json"), true);
        foreach ($angulaRules as $angulaRule) {
            if(!empty($menuNext[$angulaRule['UNIQUE_ID']])){
                foreach ($menuNext[$angulaRule['UNIQUE_ID']] as $menuNode) {
                    $angulaRules[] = [
                        "NRPERFILACESSO" => $angulaRule['NRPERFILACESSO'],
                        "UNIQUE_ID" => $menuNode,
                    ];
                }
            }
        }
        return $angulaRules;
    }

    protected static function getAngulaRules($nrorg, $projectId)
    {
        $query = <<<SQL
                SELECT P.NRPERFILACESSO, P.NMPERFILACESSO, E.UNIQUE_ID, E.LABEL, R.RULE
                  FROM PERFILACESSO P
                  JOIN ZHU_ACCESS_CONTROL_RULE R ON R.GROUP_ID = P.NRPERFILACESSO
                                                AND R.RULE = 'I'
                  JOIN ZHU_ACCESS_CONTROL_ELEMENT E ON R.ACCESS_CONTROL_ELEMENT_ID = E.ID
                                                   AND E.PROJECT_ID = $projectId
                                                   AND E.TYPE = 'M'
                 WHERE P.IDATIVO = 'S' AND P.NRORG = $nrorg

SQL;
        $entityManager = InstanceManager::getInstance()->getService('connectionCustom')->updateVpdConnection($nrorg, true);
        return $entityManager->getConnection()->fetchAll($query);
    }

        protected static function getPerfilAccess($nrorg){
            $query = <<<SQL
                SELECT P.NRPERFILACESSO, P.NMPERFILACESSO
                  FROM PERFILACESSO P
                 WHERE P.IDATIVO = 'S' AND P.NRORG = $nrorg

SQL;
            $entityManager = InstanceManager::getInstance()->getService('connectionCustom')->updateVpdConnection($nrorg,true);
            $return = $entityManager->getConnection()->fetchAll($query);
            $perfis = [];
            foreach ($return as $item) {
                $perfis[$item['NRPERFILACESSO']] = [];
            }
            return $perfis;
        }

    protected static function getMenuNode($menuNext, $menu = [], $menuTree = [],$parent = [])
    {
        foreach ($menuNext as $item) {
            if ($item['data']['type'] === 'MENU') {
                if (empty($item['children'])) {
                    $menu[] = $item['data']['label'];
                    $menuTree[$item['data']['label']] = empty($parent['data']['tree']) ? [] : $parent['data']['tree'];
                } else {
                    if(empty($parent['data']['tree'])){
                        $item['data']['tree'] = [$item['data']['label']];
                    } else {
                        $item['data']['tree'] = $parent['data']['tree'];
                        $item['data']['tree'][] = $item['data']['label'];
                    }
                    list($menu,$menuTree) = self::getMenuNode($item['children'], $menu, $menuTree, $item);
                }
            }
        }
        return array($menu,$menuTree);
    }

    /**
     * @param $angulaRules
     * @param array $arrayElementPorPerfil
     * @param mixed $menusNodeNext
     * @param array $arrayElementPorPerfilNext
     * @return array
     */
    public static function getElementsNextByAngula($angulaRules, array $arrayElementPorPerfil, array $menusNodeNext,
                                                   array $arrayElementPorPerfilNext, array $menuTreeNext): array
    {
        foreach ($angulaRules as $angulaRule) {
            $arrayElementPorPerfil[$angulaRule['NRPERFILACESSO']][] = $angulaRule['UNIQUE_ID'];
        }
        foreach ($arrayElementPorPerfil as $key => $perfil) {
            if (empty($perfil)) {
                $arrayElementPorPerfilNext[$key] = $menusNodeNext;
            } else {
                foreach ($menusNodeNext as $element) {
                    if (!in_array($element, $perfil)) {
                        $arrayElementPorPerfilNext[$key][] = $element;
                        foreach ($menuTreeNext[$element] as $elementParent) {
                            if(!in_array($elementParent, $arrayElementPorPerfilNext[$key])){
                                $arrayElementPorPerfilNext[$key][] = $elementParent;
                            }
                        }
                    }
                }
            }
        }
        return $arrayElementPorPerfilNext;
    }

    public static function savePerfilacessoLabel($element, $nrperfilacesso, $nrorg){
        $perfilAccessNext = self::getPerfilAccessNext($element, $nrperfilacesso, $nrorg);
        if(empty($perfilAccessNext)) {
            $newCode = InstanceManager::getInstance()->getService('newCodeSC')->getCodeByTableName('PERFILACESSO_LABEL', $nrorg, 1, 10, true);
            self::insertPerfilacessoLabel($newCode, $element, $nrperfilacesso, $nrorg, 'S', '1');
        }
    }

    public static function insertPerfilacessoLabel($id, $label, $nrperfilacesso, $nrorg, $idativo, $cdoperinclusao)
    {
        $query =  <<<SQL
                        INSERT INTO PERFILACESSO_LABEL
                              (ID, LABEL, NRPERFILACESSO, NRORG, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
                       VALUES (:ID, :LABEL, :NRPERFILACESSO, :NRORG, :IDATIVO, SYSDATE, :NRORG, :CDOPERINCLUSAO)
SQL;
        $params = array(
            'ID' => $id,
            'LABEL' => $label,
            'NRPERFILACESSO' => $nrperfilacesso,
            'NRORG' => $nrorg,
            "IDATIVO" => $idativo,
            "CDOPERINCLUSAO" => $cdoperinclusao,
        );

        try {
            $entityManager = InstanceManager::getInstance()->getService('connectionCustom')->updateVpdConnection($nrorg,true);
            $std = $entityManager->getConnection()->prepare($query);
            $std->executeQuery($params);
        } catch (\Doctrine\DBAL\Driver\Exception $e) {
            throw new $e;
        }
    }

    protected static function getPerfilAccessNext($label, $nrperfilacesso, $nrorg){
        $query = <<<SQL
                SELECT * 
                FROM PERFILACESSO_LABEL 
                WHERE NRORG = :NRORG 
                  AND LABEL = :LABEL
                  AND NRPERFILACESSO = :NRPERFILACESSO

SQL;
        $params = array(
            'LABEL' => $label,
            'NRPERFILACESSO' => $nrperfilacesso,
            'NRORG' => $nrorg,
        );
        /** @var \Doctrine\ORM\EntityManager $entityManager */
        $entityManager = InstanceManager::getInstance()->getService('connectionCustom')->updateVpdConnection($nrorg,true);
        return $entityManager->getConnection()->fetchAll($query, $params);
    }
}